#ifndef CATHARSIS_CATHARSIS_H
#define CATHARSIS_CATHARSIS_H

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif

#ifndef GRAPHICS_GFX_H
#include <graphics/gfx.h>
#endif

#ifndef GRAPHICS_RASTPORT_H
#include <graphics/rastport.h>
#endif

#ifndef GRAPHICS_TEXT_H
#include <graphics/text.h>
#endif

/* Type definitions */

struct CharInfo
{
	unsigned short offset;
	unsigned short size;
};

struct CharArray
{
	struct CharInfo CharIndex[256];		// Points to each character's CharInfo (see above)
};

/* This table is internally used for decoding and only temporarily allocated! */
struct	FontDescription
{
	struct RastPort	RPort;		// For existing, encoded data of font
	struct BitMap	BMap;
	struct RastPort	DestRP;		// For the newly, slightly changed font data
	struct BitMap	DestBM;

	unsigned char *Data;		// Font data information pointer
	unsigned short BytesPerRow;	// Complete line with information for all chars

	unsigned short LowChar;		// e.g. 32
	unsigned short HiChar;		// e.g. 255

	unsigned short CharHeight;	// Height of this char
	unsigned short CharOffset;	// The offset in pixels to reach the information for this char in "data"
	unsigned short CharWidth;	// The amount of information stored per line for this char (e.g. 9)
};

#endif
