#ifndef CATHARSIS_CATHARSISBASE_H
#define CATHARSIS_CATHARSISBASE_H

#ifndef EXEC_EXECBASE_H
#include <exec/execbase.h>
#endif

#ifndef DOS_DOS_H
#include <dos/dos.h>
#endif

#ifndef GRAPHICS_GFXBASE_H
#include <graphics/gfxbase.h>
#endif

#ifndef GRAPHICS_TEXT_H
#include <graphics/text.h>
#endif

#ifndef INTUITION_INTUITIONBASE_H
#include <intuition/intuitionbase.h>
#endif

struct CatharsisBase
{
	struct Node cts_LibNode;
	UBYTE		cts_Flags;			// LIB Flags
	UBYTE		cts_Pad0;			// Dummy
	UWORD		cts_NegSize;		// LIB Negative size (function table)
	UWORD		cts_PosSize;		// LIB Positive size (it's this table)
	UWORD		cts_Version;		// LIB Version
	UWORD		cts_Revision;		// LIB Revision
	char	   *cts_IdString;		// LIB Detail string
	ULONG		cts_Sum;			// LIB Checksum
	UWORD		cts_OpenCnt;		// LIB Open count
	UWORD		cts_Reserved1;		// - Internally used (in the future...)
	BPTR		cts_SegList;		// LIB Segment pointer
	void	   *cts_Reserved2;		// As it tells
	struct ExecBase		 *cts_SysBase;				// Base pointers
	struct GfxBase		 *cts_GfxBase;
	struct IntuitionBase *cts_IntuitionBase;
	struct TextFont		 *cts_TextFont[256];		// Remembered TextFont pointers
	struct TextFont		 *cts_CatharsisFont[256];	// Created TextFont pointers
};

#endif
